; $Id: hfbs_gaussian.pro,v 1.2 2002/01/14 20:59:25 amunter Exp $
function hfbs_gaussian,x,area = area,cen = cen,wid = wid
if n_elements(area) eq 0 then area = 1.0
if n_elements(cen) eq 0 then cen = 0.0
if n_elements(wid) eq 0 then wid = 1.0
sig = wid/2.35
y = (area/sqrt(2.0*!dpi*sig^2))*exp(-0.5*((x-cen)/sig)^2)
return,y
end