; $Id: dave_expand_expr.pro,v 1.3 2002/07/17 20:40:33 amunter Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
function dave_expand_expr,incom,longform=longform,shortform=shortform
;************************************************************************************************
;
compile_opt strictarr
;
;
if (not keyword_set(shortform)) then begin
; If necessary, given the long forms of variables (longform),
;	construct corresponding short forms (shortform).
	nvar=n_elements(longform)
	shortform=longform
	for k=0,nvar-1 do begin
		shortform[k]=strmid(longform[k],strpos(longform[k],".",/reverse_search)+1)
	endfor
endif
;
; Given an input command string (incom), generate and return the
; corresponding output command string.
com=strupcase(incom)
outcom=""
while (1) do begin
	pos=stregex(com,"[a-zA-Z][a-zA-Z0-9_]*",length=len)
	if (pos gt 0) then outcom=outcom+strmid(com,0,pos)
	if (pos eq -1) then begin
		outcom=outcom+com
		break
	endif
	var=strmid(com,pos,len)
	k=where(var eq strupcase(shortform),n)
	if (n eq 1) then var=strupcase(longform[k[0]])
	outcom=outcom+var
	com=strmid(com,pos+len)
endwhile
return,outcom
end