; $Id: dcs_general_collapse.pro,v 1.3 2002/07/17 20:39:14 amunter Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro dcs_general_collapse,x,xf
;************************************************************************************************
;
compile_opt strictarr
;
;
; This procedure takes an unsorted integer array x and collapses it.
; Collapsing is best illustrated with an example:
;    If x=[1,2,1,2,4,0,6,7,6,4,8,10,5,13,2,22]
; then xf=[1,2,1,2,3,0,5,6,5,3,7, 8,4, 9,2,10]
;
xs=x[sort(x)]
xu=xs[uniq(xs)]
nxu=n_elements(xu)
xf=x
for k=0,nxu-1 do begin
	indices=where(x eq xu[k],count)
	if (count eq 0) then begin
		xf=0
		return
	endif
	xf[indices]=k
endfor
end
